.\"	$NetBSD: chroot.2,v 1.21 2003/08/07 16:43:56 agc Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)chroot.2	8.1 (Berkeley) 6/4/93
.\"
.Dd April 18, 2001
.Dt CHROOT 2
.Os
.Sh NAME
.Nm chroot
.Nd change root directory
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn chroot "const char *dirname"
.Ft int
.Fn fchroot "int fd"
.Sh DESCRIPTION
.Fa dirname
is the address of the pathname of a directory, terminated by an ASCII NUL.
.Fn chroot
causes
.Fa dirname
to become the root directory,
that is, the starting point for path searches of pathnames
beginning with
.Ql / .
.Pp
In order for a directory to become the root directory
a process must have execute (search) access for that directory.
.Pp
If the current working directory is not at or under the new root
directory, it is silently set to the new root directory.
It should be noted that, on most other systems,
.Fn chroot
has no effect on the process's current directory.
.Pp
This call is restricted to the super-user.
.Pp
The
.Fn fchroot
function performs the same operation on an open directory file
known by the file descriptor
.Fa fd .
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.
Otherwise, a value of \-1 is returned and
.Va errno
is set to indicate an error.
.Sh ERRORS
.Fn chroot
will fail and the root directory will be unchanged if:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of the path name is not a directory.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded
.Dv {NAME_MAX}
characters, or an entire path name exceeded
.Dv {PATH_MAX}
characters.
.It Bq Er ENOENT
The named directory does not exist.
.It Bq Er EACCES
Search permission is denied for any component of the path name.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating the pathname.
.It Bq Er EFAULT
.Fa dirname
points outside the process's allocated address space.
.It Bq Er EIO
An I/O error occurred while reading from or writing to the file system.
.It Bq Er EPERM
The effective user ID of the calling process is not the super-user.
.El
.Pp
.Fn fchroot
will fail and the root directory will be unchanged if:
.Bl -tag -width Er
.It Bq Er EACCES
Search permission is denied for the directory referenced
by the file descriptor.
.It Bq Er EBADF
The argument
.Fa fd
is not a valid file descriptor.
.It Bq Er EIO
An I/O error occurred while reading from or writing to the file system.
.It Bq Er ENOTDIR
The argument
.Fa fd
does not reference a directory.
.It Bq Er EPERM
The effective user ID of the calling process is not the super-user.
.El
.Sh SEE ALSO
.Xr chdir 2
.Sh STANDARDS
The
.Fn chroot
function conforms to
.St -xsh5 ,
with the restriction that the calling process' working directory must be at
or under the new root directory.
Otherwise, the working directory is silently set to the new root directory;
this is an extension to the standard.
.Pp
.Fn chroot
was declared a legacy interface, and subsequently removed in
.St -p1003.1-2001 .
.Sh HISTORY
The
.Fn chroot
function call appeared in
.Bx 4.2 .
Working directory handling was changed in
.Nx 1.4
to prevent one way a process could use a second
.Fn chroot
call to a different directory to "escape" from the restricted subtree.
The
.Fn fchroot
function appeared in
.Nx 1.4 .
